#ifndef POLIGON_H_INCLUDED
#define POLIGON_H_INCLUDED

#include <vector>
#include "pont.h"

class Poligon : public Alakzat
{
    std::vector<pont> v;

public:
    enum errors {UNIMPLEMENTED};
    Poligon(const std::vector<pont>& t):v(t){}

    double terulet()const{ throw UNIMPLEMENTED; }

    bool rajtavan(pont p)
    {
        bool ok = true;
        // optimista eldnts: minden oldalon bell van-e
        for(int i=0;i<v.size();++i)
        {
            int j = next(i);
            // [x,y] az oldalvektor
            // [-y,x] a +90 fokos elforgatottja
            double x = v[j].getX()-v[i].getX();
            double y = v[j].getY()-v[i].getY();

            // [a,b] az oldal kezdpontjbl a pontba mutat vektor
            double a = p.getX()-v[i].getX();
            double b = p.getY()-v[i].getY();

            // <[-y,x],[a,b]> skalris szorzat pozitv => bell van ezen az oldalon
            ok = ok && (-a*y+b*x >= 0);
        }
        return ok;
    }
private:
    // Megadja egy cscspont rkvetkezjt
    int next(int i)
    {
        if(i == v.size()-1) return 0;
        else return i+1;
    }
};

#endif // POLIGON_H_INCLUDED
